﻿<%@ Page Title="Home Page" Language="C#" MasterPageFile="~/Site.Master" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="ScheduleCRUDCS._Default" %>

<%@ Register Assembly="Syncfusion.EJ.Web, Version=15.3450.0.33, Culture=neutral, PublicKeyToken=3d67ed1f87d44c89" Namespace="Syncfusion.JavaScript.Web" TagPrefix="ej" %>

<asp:Content ID="BodyContent" ContentPlaceHolderID="MainContent" runat="server">
    <ej:Schedule ID="Schedule1" ClientIDMode="Static" Height="525px" Width="100%" CurrentDate="10/10/2015" runat="server" DataSourceID="SqlDataSource1" AppointmentWindowOpen="onAppointmentWindowOpen">
        <Resources>
        <ej:Resources Field="OwnerId" Name="Owners" Title="Owner" AllowMultiple="false">
            <ResourceSettings Color="color" Id="id" Text="text" GroupId="groupId">
            </ResourceSettings>
        </ej:Resources>         
    </Resources>
    <Group Resources="Owners"/>
        <AppointmentSettings ApplyTimeOffset="false" Id="Id" Subject="Subject" AllDay="AllDay" StartTime="StartTime" EndTime="EndTime" Description="Description" Recurrence="Recurrence" ResourceFields="OwnerId" />
    </ej:Schedule>
    <asp:SqlDataSource ID="SqlDataSource1" runat="server" ConnectionString="<%$ ConnectionStrings:ConnectionString %>" SelectCommand="SELECT * FROM [MultipleResource]"></asp:SqlDataSource>
    <div id="customWindow" style="display: none">
        <form id="custom">
            <table width="100%" cellpadding="5">
                <tbody>
                    <tr style="display: none">
                        <td>Id:
                        </td>
                        <td colspan="2">
                            <input id="customId" type="text" name="Id" />
                        </td>
                    </tr>
                    <tr>
                        <td>Subject:
                        </td>
                        <td colspan="2">
                            <input id="subject" type="text" value="" name="Subject" onfocus="temp()" style="width: 100%" />
                        </td>
                    </tr>
                    <tr>
                        <td>Description:
                        </td>
                        <td colspan="2">
                            <textarea id="customdescription" name="Description" rows="3" cols="50" style="width: 100%; resize: vertical"></textarea>
                        </td>
                    </tr>
                    <tr>
                        <td>Owner:
                        </td>
                        <td colspan="2">
                            <input id="OwnerId" type="text" />
                        </td>
                    </tr>
                    <tr>
                        <td>StartTime:
                        </td>
                        <td><input id="StartTime" type="text" value="" name="StartTime" /> </td>
                    </tr>
                    <tr>
                        <td>EndTime:
                        </td>
                        <td><input id="EndTime" type="text" value="" name="EndTime" />  </td>
                    </tr>
                    <tr>
                        <td colspan="3">
                            <div class="customcheck">AllDay:</div>
                            <div class="customcheck">
                                <input id="allday" type="checkbox" name="AllDay" onchange="alldayCheck()" />
                            </div>
                            <div class="customcheck">Recurrence:</div>
                            <div>
                                <input id="recurrence" type="checkbox" name="Recurrence" onchange="recurCheck()" />
                            </div>
                        </td>
                    </tr>
                    <tr class="recurrence" style="display: none">
                        <td>Type:
                        </td>
                        <td>
                            <select id="rType" name="freq">
                                <option value="daily">Daily</option>
                                <option value="weekly">Weekly</option>
                                <option value="monthly">Monthly</option>
                                <option value="yearly">Yearly</option>
                            </select>
                        </td>
                    </tr>
                </tbody>
            </table>
        </form>
        <div>
            <button type="submit" onclick="cancel()" id="btncancel" style="float: right; margin-right: 20px; margin-bottom: 10px;">Cancel</button>
            <button type="submit" onclick="save()" id="btnsubmit" style="float: right; margin-right: 20px; margin-bottom: 10px;">Submit</button>
        </div>
    </div>

    <script>
        $(function () {
            ownerData = [{ text: "Nancy", id: 1, groupId: 1, color: "#f8a398" },
                         { text: "Steven", id: 2, groupId: 2, color: "#56ca85" },
                         { text: "Michael", id: 3, groupId: 1, color: "#51a0ed" }];
            $("#customWindow").ejDialog({
                width: 600,
                height: "auto",
                position: { X: 400, Y: 200 },
                showOnInit: false,
                enableModal: true,
                title: "Create Appointment",
                enableResize: false,
                allowKeyboardNavigation: false,
                close: "clearFields"
            });
            $("#StartTime").ejDateTimePicker({ width: "150px" });
            $("#EndTime").ejDateTimePicker({ width: "150px" });
            $("#btncancel").ejButton({ width: '85px' });
            $("#btnsubmit").ejButton({ width: '85px' });
            $("#OwnerId").ejAutocomplete({
                showPopupButton: true,
                dataSource: ownerData,
                fields: { text: "text", key: "id" },
                width: "100%"
            });
        });
        function onAppointmentWindowOpen(args) {
            args.cancel = true;
            var quickobj = $("#Schedule1AppointmentQuickWindow").data("ejDialog");
            var Object = $("#OwnerId").data("ejAutocomplete");
            quickobj.close();

            $("#StartTime").ejDateTimePicker({ value: args.startTime });
            $("#EndTime").ejDateTimePicker({ value: args.endTime });
            if (!ej.isNullOrUndefined(args.target)) {
                if ($(args.target.currentTarget).hasClass("e-alldaycells"))
                    $("#allday").prop("checked", true);
                else
                    args.model.currentView == "month" ? $("#allday").prop("checked", true) : $("#allday").prop("checked", false);
                $("#StartTime,#EndTime").ejDateTimePicker({ enabled: ($(args.target.currentTarget).hasClass("e-alldaycells") || $(args.target.currentTarget).hasClass("e-monthcells") || args.model.currentView == "month") ? false : true });
            }
            if (!ej.isNullOrUndefined(args.appointment)) {
                $("#customId").val(args.appointment.Id);
                $("#subject").val(args.appointment.Subject);
                $("#customdescription").val(args.appointment.Description);

                var Value = ej.DataManager(Object.model.dataSource).executeLocal(new ej.Query().where("id", "equal", args.appointment.OwnerId));
                $("#OwnerId").ejAutocomplete("clearText");
                $("#OwnerId").data("ejAutocomplete").selectValueByKey(Value[0].id);

                $("#StartTime").ejDateTimePicker({ value: new Date(args.appointment.StartTime) });
                $("#EndTime").ejDateTimePicker({ value: new Date(args.appointment.EndTime) });
                $("#allday").prop("checked", args.appointment.AllDay);
                $("#recurrence").prop("checked", args.appointment.Recurrence);
                if (args.appointment.Recurrence) {
                    $("#rType").val(args.appointment.RecurrenceRule.split(";")[0].split("=")[1].toLowerCase());
                    $("tr.recurrence").css("display", "table-row");
                }
                $("#customWindow").ejDialog("open");
            }
            else {
                var Value = ej.DataManager(Object.model.dataSource).executeLocal(new ej.Query().where("id", "equal", args.resources.id));
                $("#OwnerId").ejAutocomplete("clearText");
                if (this.model.resources[0].allowMultiple)
                    var mode = "visualmode";
                else
                    var mode = "none";
                $("#OwnerId").ejAutocomplete("option", "multiSelectMode", mode);
                $("#OwnerId").data("ejAutocomplete").selectValueByKey(Value[0].id);
                $("#customWindow").ejDialog("open");
            }
        }

        function save() {
            if ($.trim($("#subject").val()) == "") {
                $("#subject").addClass("error");
                return false;
            }
            var obj = {};
            obj["Id"] = $("#customId").val() == "" ? $("#customId").val() : parseInt($("#customId").val());
            obj["Subject"] = $("#subject")[0].value;            
            obj["Description"] = $("#customdescription")[0].value;
            obj["StartTime"] = new Date($("#StartTime")[0].value);
            obj["EndTime"] = new Date($("#EndTime")[0].value);
            obj["AllDay"] = $("#allday")[0].checked;
            obj["Recurrence"] = $("#recurrence")[0].checked;
            if (obj.Recurrence) {
                if (temp.freq.toUpperCase() == "DAILY")
                    obj["RecurrenceRule"] = "FREQ=DAILY;INTERVAL=1;COUNT=5";
                else if (temp.freq.toUpperCase() == "WEEKLY")
                    obj["RecurrenceRule"] = "FREQ=WEEKLY;BYDAY=MO,WE,TH;INTERVAL=1;COUNT=10";
                else if (temp.freq.toUpperCase() == "MONTHLY")
                    obj["RecurrenceRule"] = "FREQ=MONTHLY;BYMONTHDAY=" + obj.StartTime.getDate() + ";INTERVAL=1;COUNT=5";
                else if (temp.freq.toUpperCase() == "YEARLY")
                    obj["RecurrenceRule"] = "FREQ=YEARLY;BYMONTHDAY=" + obj.StartTime.getDate() + ";BYMONTH=" + (obj.StartTime.getMonth() + 1) + ";INTERVAL=1;COUNT=3";
            }
            else
                obj["RecurrenceRule"] = null;
            var Object = $("#OwnerId").data("ejAutocomplete");
            var ownrData = ej.DataManager(Object.model.dataSource).executeLocal(new ej.Query().where("text", "equal", $("#OwnerId")[0].value));
            obj["OwnerId"] = ownrData[0].id;
            $("#customWindow").ejDialog("close");
            var object = $("#Schedule1").data("ejSchedule");
            if (obj.Recurrence) {
                var recurEdit = object._appointmentAddWindow.find(".e-recurrenceeditor").data("ejRecurrenceEditor");
                recurEdit._recRule = obj[object._appointmentSettings["recurrenceRule"]];
            }
            object.saveAppointment(obj);
            clearFields();
        }

        function clearFields() {
            $("#customId").val("");
            $("#subject").val("");
            $("#Customer").ejDropDownList("clearText");
            $("#OwnerId").ejAutocomplete("clearText");
            $("#customdescription").val("");
            $("#allday").prop("checked", false);
            $("#recurrence").prop("checked", false);
            document.getElementById("rType").selectedIndex = "0";
            $("tr.recurrence").css("display", "none");
        }

        function recurCheck() {
            if ($("#recurrence").get(0).checked == true)
                $("tr.recurrence").css("display", "table-row");
            else
                $("tr.recurrence").css("display", "none");
        }

        function alldayCheck() {
            if ($("#allday").prop("checked")) {
                var a = $("#StartTime").data("ejDateTimePicker").model.value;
                a.setHours(0, 0, 0);
                var b = $("#EndTime").data("ejDateTimePicker").model.value;
                b.setHours(23, 59, 0);
                $("#StartTime").ejDateTimePicker({ value: new Date(a), enabled: false });
                $("#EndTime").ejDateTimePicker({ value: new Date(b), enabled: false });
            }
            else {
                $("#StartTime").ejDateTimePicker({ enabled: true });
                $("#EndTime").ejDateTimePicker({ enabled: true });
            }
        }

        function temp() {
            $("#subject").removeClass("error");
        }

        function cancel() {
            clearFields();
            $("#customWindow").ejDialog("close");
        }
    </script>
    <style>
        .customcheck {
            float: left;
            margin-right: 10px;
        }

        .error {
            background-color: #FF8A8A;
        }

        #custom table td {
            padding: 5px;
        }
    </style>
</asp:Content>

